﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace ConsoleApp1
{
    internal class Program
    {
        static void Main(string[] args)
        {
            // Create https://travistidwell.com/jsencrypt/demo/
            var keyFilePath = @"key.pem";
            var plainData = "HelloWorld";
            var encData = Program.Encrypt(keyFilePath, plainData);
            var deData = Program.Decrypt(keyFilePath, encData);

            Console.WriteLine("<<< 원본 >>>");
            Console.WriteLine(plainData);
            Console.WriteLine(string.Empty);
            Console.WriteLine("<<< 암호화 >>>");
            Console.WriteLine(encData);
            Console.WriteLine(string.Empty);
            Console.WriteLine("<<< 복호화 >>>");
            Console.WriteLine(deData);
            Console.WriteLine(string.Empty);
        }

        public static string Encrypt(string keyFilePath, string data)
        {
            var result = string.Empty;

            using (var sr = File.OpenText(keyFilePath))
            {
                using (var pr = new Org.BouncyCastle.OpenSsl.PemReader(sr))
                {
                    var ackp = (pr.ReadObject() as Org.BouncyCastle.Crypto.AsymmetricCipherKeyPair);

                    if (ackp != null)
                    {
                        var cipher = Org.BouncyCastle.Security.CipherUtilities.GetCipher("RSA/NONE/OAEPWITHSHA256ANDMGF1PADDING");
                        cipher.Init(true, ackp.Public);

                        var plain = Encoding.UTF8.GetBytes(data);
                        var plainUse = cipher.DoFinal(plain);

                        result = Convert.ToBase64String(plainUse);
                    }
                    else
                    {
                        throw new Exception($"키 읽기에 실패했습니다.");
                    }
                }

                sr.Close();
            }

            return result;
        }

        public static string Decrypt(string keyFilePath, string data)
        {
            var result = string.Empty;

            using (var sr = File.OpenText(keyFilePath))
            {
                using (var pr = new Org.BouncyCastle.OpenSsl.PemReader(sr))
                {
                    var ackp = (pr.ReadObject() as Org.BouncyCastle.Crypto.AsymmetricCipherKeyPair);

                    if (ackp != null)
                    {
                        var cipher = Org.BouncyCastle.Security.CipherUtilities.GetCipher("RSA/NONE/OAEPWITHSHA256ANDMGF1PADDING");
                        cipher.Init(false, ackp.Private);

                        var plain = cipher.DoFinal(Convert.FromBase64String(data));

                        result = Encoding.UTF8.GetString(plain);
                    }
                    else
                    {
                        throw new Exception($"키 읽기에 실패했습니다.");
                    }
                }

                sr.Close();
            }

            return result;
        }
    }
}
