﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace ConsoleApp2
{
    internal class Program
    {
        static void Main(string[] args)
        {
            // Create Hyper-V Ubuntu 
            // openssl genrsa 2048
            var keyFilePath = @"key.pem";
            var plainData = "HelloWorld";
            var encData = Program.Encrypt(keyFilePath, plainData);
            var deData = Program.Decrypt(keyFilePath, encData);

            Console.WriteLine("<<< 원본 >>>");
            Console.WriteLine(plainData);
            Console.WriteLine(string.Empty);
            Console.WriteLine("<<< 암호화 >>>");
            Console.WriteLine(encData);
            Console.WriteLine(string.Empty);
            Console.WriteLine("<<< 복호화 >>>");
            Console.WriteLine(deData);
            Console.WriteLine(string.Empty);
        }

        public static string Encrypt(string keyFilePath, string data)
        {
            var result = string.Empty;

            using (var sr = File.OpenText(keyFilePath))
            {
                using (var pr = new Org.BouncyCastle.OpenSsl.PemReader(sr))
                {
                    //var ackp = (pr.ReadObject() as Org.BouncyCastle.Crypto.AsymmetricCipherKeyPair); // ConsoleApp1
                    var ackp = (pr.ReadObject() as Org.BouncyCastle.Crypto.Parameters.RsaPrivateCrtKeyParameters);

                    if (ackp != null)
                    {
                        try
                        {
                            var cipher = Org.BouncyCastle.Security.CipherUtilities.GetCipher("RSA/NONE/OAEPWITHSHA256ANDMGF1PADDING");
                            //cipher.Init(true, ackp.Public); // ConsoleApp1
                            cipher.Init(true, ackp);

                            var plain = Encoding.UTF8.GetBytes(data);
                            var plainUse = cipher.DoFinal(plain);

                            result = Convert.ToBase64String(plainUse);
                        }
                        catch (Exception ex)
                        {
                            result = $"[ERROR] {ex.Message}{Environment.NewLine}{ex.StackTrace}";
                        }
                    }
                    else
                    {
                        throw new Exception($"키 읽기에 실패했습니다.");
                    }
                }

                sr.Close();
            }

            return result;
        }

        public static string Decrypt(string keyFilePath, string data)
        {
            var result = string.Empty;

            using (var sr = File.OpenText(keyFilePath))
            {
                using (var pr = new Org.BouncyCastle.OpenSsl.PemReader(sr))
                {
                    //var ackp = (pr.ReadObject() as Org.BouncyCastle.Crypto.AsymmetricCipherKeyPair); // ConsoleApp1
                    var ackp = (pr.ReadObject() as Org.BouncyCastle.Crypto.Parameters.RsaPrivateCrtKeyParameters);

                    if (ackp != null)
                    {
                        try
                        {
                            var cipher = Org.BouncyCastle.Security.CipherUtilities.GetCipher("RSA/NONE/OAEPWITHSHA256ANDMGF1PADDING");
                            //cipher.Init(false, ackp.Private); // ConsoleApp1
                            cipher.Init(false, ackp);

                            var plain = cipher.DoFinal(Convert.FromBase64String(data));

                            result = Encoding.UTF8.GetString(plain);
                        } 
                        catch(Exception ex)
                        {
                            result = $"[ERROR] {ex.Message}{Environment.NewLine}{ex.StackTrace}";
                        }
                    }
                    else
                    {
                        throw new Exception($"키 읽기에 실패했습니다.");
                    }
                }

                sr.Close();
            }

            return result;
        }
    }
}
